#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdlib.h>

#include <avr/io.h>
#include <util/delay.h>

#include "lcd_config.h"

#include "lcd.h"

#define ARRAY_LEN(x) (sizeof(x) / sizeof *(x))

/* Initialize SPI interface
 *
 * Read the Atmel spec sheet and LCD driver spec sheet
 */
static void
spi_init(void)
{
}

/* Initialize the LED backlight.
 *
 * Look at Timer/Counter4 and the schematic */
static void
led_init(void)
{
}

/* Write to the LCD via spi */
static void
spi_write(uint8_t c)
{
}

/* Interpret SPI bytes as commands */
static void
lcd_cmd(void)
{
  A0_PORT &= ~_BV(A0);
}

/* Interpret SPI bytes as image data */
static void
lcd_data(void)
{
}

/* Initializes the LCD and Backlight,
 * but does not turn it on yet
 *
 * Review the LCD spec sheet for correct
 * initialization routine.
 */
void
lcd_init(void)
{
}

/* Turn the display on */
void
lcd_on()
{
}

/* Turn the display off */
void
lcd_off()
{
}

/* Set the backlight (LED) PWM duty cycle
 *
 * Review schematics... :) 
 */
void
lcd_led_set(uint8_t level)
{
}

/* Sets LCD volume (contrast) */
void
lcd_volume_set(uint8_t level)
{
}

/* Retets LCD; different from blanking/clearing */
void
lcd_reset(void)
{
}

void
lcd_sleep(void)
{
}

void
lcd_wake(void)
{
}

/* Scrolls the LCD by setting the display start line */
void
lcd_scroll(uint8_t y)
{
}

/* Fills the LCD with the specified byte value */
void
lcd_fill(uint8_t c)
{
}

/* Clears the LCD */
void
lcd_clear(void)
{
  lcd_fill(0x00);
}

/* Dumps a text buffer to the LCD
 *
 * Text buffer = array of 8 strings
 *
 * Converts each character to a glyph for
 * printing
 */
void
lcd_flush_text(lcd_text_buffer_t const buf)
{
  /* ... */
  glyph_t const *g = ascii_to_glyph(c);
  for (uint8_t col = 0; col < 8; ++col) {
    if (col < GLYPH_WIDTH) spi_write(g->cols[col]);
    else spi_write(0);
  }
}

/* Dumps a pixel buffer to the LCD
 *
 * Pixel buffer = raw pixel data
 */
void
lcd_flush_pixels(lcd_pixel_buffer_t const buf)
{
  for (size_t y = 0; y < LCD_PAGE_COUNT; ++y) {
    lcd_cmd();
    spi_write(PAGE_ADDR_SET(y));
    spi_write(COL_ADDR_SET_UPPER(0));
    spi_write(COL_ADDR_SET_LOWER(0));

    lcd_data();
    for (size_t x = 0; x < LCD_COLUMN_COUNT; ++x) {
      uint8_t c = buf[y][x];
      spi_write(c);
    }
  }
}
